mod Mxml

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_tp_list
  Fenced(Op('[',0),Arg(0),Op(']',0))

appldisp/2 Tex_f2_tp_sgn
  Infix(Arg(0),0,1,Op('::',0),Arg(1))

rem 
  \para \bf  Part. XML Documents  \end 

rem 
  \para \bf  Attributes of XML elements.  \end Type declaration(s): 
  \eq* 
    Attr = Str,Str
  \end
  \eq* 
    Attrs = Tex_f1_tp_list(Attr)
  \end

pred Attr 
  Attr(name,value) <- Str(name) & Str(value)

pred Attrs 
  Attrs(0)
  Attrs(attribute,attributes) <- Attr(attribute) & Attrs(attributes)

rem 
  \para \bf  Constructors of XML elements.  \end Type signature(s): 
  \eq* 
    Tex_f2_tp_sgn(Xe,(Str,Tex_f1_tp_list(Attr),Tex_f1_tp_list(X) -> X))
  \end
  \eq* 
    Tex_f2_tp_sgn(Xs,(Str -> X))
  \end

fun/3 Xe 
  Xe(name,attributes,content) = 0,name,attributes,content

fun Xs 
  Xs(text) = 1,text

rem 
  \para \bf  XML documents.  \end Type declaration(s): 
  \eq* 
    Xml = Tex_f1_tp_list(X)
  \end

pred Xml 
  Xml(0)
  Xml(Xe(name1,attributes1,content1),content2) <- 
    Str(name1) & Attrs(attributes1) & Xml(content1) & Xml(content2)
  Xml(Xs(text1),content2) <- Str(text1) & Xml(content2)

rem 
  \para \bf  Part. XHTML Documents.  \end 

rem 
  \para \bf  XHTML document skeleton.  \end \header* fun/2 Xhtml  \end Type 
  signature(s): 
  \eq* 
    Tex_f2_tp_sgn(Xhtml,(Str,Tex_f1_tp_list(X) -> Tex_f1_tp_list(X)))
  \end
  \para Note that \ft L Xhtml(n,c) = 1 \end. 

fun/2 Xhtml 
  Xhtml(headtitlename,bodycontent) = 
  Xe('html',(('xmlns','http://www.w3.org/1999/xhtml'),0),head,body,0),0 <- 
    Xe('head',0,Xe('title',0,Xs(headtitlename),0),0) = head & 
    Xe('body',0,bodycontent) = body

rem 
  \para \bf  Part. Utilities.  \end 

rem 
  \para \bf  Displaying numbers in decimal notation.  \end Type signature(s): 
  \eq* 
    Tex_f2_tp_sgn(N2s,(N -> Str))
  \end
  \eq* 
    Tex_f2_tp_sgn(N2x,(N -> X))
  \end
  \eq* 
    Tex_f2_tp_sgn(N2xml,(N -> Tex_f1_tp_list(X)))
  \end

fun/2 N2s1 
  N2s1(10*q+r,s) = r+"0",s <- 0 <= r & r <= 9 & q = 0
  N2s1(10*q+r,s) = N2s1(q,r+"0",s) <- 0 <= r & r <= 9 & q != 0

fun N2s 
  N2s(n) = N2s1(n,0)

fun N2x 
  N2x(n) = Xs N2s(n)

fun N2xml 
  N2xml(n) = N2x(n),0

rem 
  \para \bf  Part. Debugging.  \end 

rem 
  \para \bf  Type errors.  \end Type declaration(s): 
  \eq* 
    Xmle = Tex_f1_tp_list(X)
  \end
  \para Use the format \ft Xmle \end for checking type errors. 

pred Xmle 
  Xmle(0)
  Xmle(Xe(n1,as1,xs1),xs2) <- Str(n1) & Attrs(as1) & Xmle(xs1) & Xmle(xs2)
  Xmle(Xs(s1),xs2) <- Str(s1) & Xmle(xs2)

